{01.08.01 : TDD : modif des procedures "xyGraphPhiMouseMove" et "xyGraphPhiMouseMove"
afin de pouvoir afficher la position sur la graphe avec des valeurs scientifiques
08.08.01 : TDD  : ajout des procedures Transfer2CurveS et TransferCurveS afin de pouvoir
afficher une serie de points dans 4 plots pour xygraph et 3 plots pour xygraphphi
               : dans FromCreate, internalzero fix a zero pour toutes les series de courbes}
{ 23.08.01 : FO : touche arrow up et down pour ajuster les echelles y d'un facteur 10 }
{25.09.01 : TDD : valeurs scientifiques quand on utilise les touches arrow up et down}
{ A FAIRE }
{ le autoscale ne marche pas correctement en echelle logarithmique      }
unit PilotageGraph2D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  xyGraph, ExtCtrls, StdCtrls, Buttons, xyDatWiz, xyDesign, EditReal, MtxVec,
  ActnList, Menus, math387, Spin;

type
  TGraph2Dform = class(TForm)
    Panel1: TPanel;
    xyGraph: TxyGraph;
    Panel2: TPanel;
    xyGraphPhi: TxyGraph;
    Panel4: TPanel;
    PrintPhi: TSpeedButton;
    RedessinerPhi: TSpeedButton;
    EditGraphPhi: TSpeedButton;
    DataPhi: TSpeedButton;
    ZoomOutPhi: TSpeedButton;
    ZoomInPhi: TSpeedButton;
    YPhiAuto: TSpeedButton;
    LinLogPhi: TButton;
    Panel3: TPanel;
    Print: TSpeedButton;
    Redessiner: TSpeedButton;
    EditGraph: TSpeedButton;
    Data: TSpeedButton;
    ZoomOut: TSpeedButton;
    ZoomIn: TSpeedButton;
    YAuto: TSpeedButton;
    LinLog: TButton;
    XAuto: TButton;
    XPhiAuto: TSpeedButton;
    xygraphRightPanel: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    XminBox: TEditReal;
    XmaxBox: TEditReal;
    YminBox: TEditReal;
    YmaxBox: TEditReal;
    xygraphphiRightPanel: TPanel;
    Label8: TLabel;
    YPhiMinBox: TEditReal;
    YPhiMaxBox: TEditReal;
    Label9: TLabel;
    Ypos: TEditReal;
    Xpos: TEditReal;
    Label2: TLabel;
    Label1: TLabel;
    Label10: TLabel;
    XphiMinBox: TEditReal;
    XPhiMaxBox: TEditReal;
    Label7: TLabel;
    Label3: TLabel;
    XPhiPos: TEditReal;
    Label4: TLabel;
    YPhiPos: TEditReal;
    Label11: TLabel;
    Label12: TLabel;
    UpdateButton: TButton;
    ClearButton: TButton;
    UpdatePhi: TButton;
    ClearPhi: TButton;
    Splitter2: TSplitter;
    TfrCurves: TCheckBox;
    tfr2curves: TCheckBox;
    SpinEditPhi: TSpinEdit;
    StoreCurves: TButton;
    StoreCurvesPhi: TButton;
    CurveSpinEdit: TSpinEdit;
    Button1: TButton;
    procedure PrintClick(Sender: TObject);
    procedure RedessinerClick(Sender: TObject);
    procedure EditGraphClick(Sender: TObject);
    procedure DataClick(Sender: TObject);
    procedure YAutoClick(Sender: TObject);
    procedure XAutoClick(Sender: TObject);
    procedure PrintPhiClick(Sender: TObject);
    procedure RedessinerPhiClick(Sender: TObject);
    procedure EditGraphPhiClick(Sender: TObject);
    procedure DataPhiClick(Sender: TObject);
    procedure YPhiAutoClick(Sender: TObject);
    procedure XPhiAutoClick(Sender: TObject);
    procedure LinLogClick(Sender: TObject);
    procedure xyGraphMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure xyGraphPhiMouseMove(Sender: TObject; Shift: TShiftState; XPhi,
      YPhi: Integer);
    procedure ClearButtonClick(Sender: TObject);
    procedure UpdateButtonClick(Sender: TObject);
    procedure ClearPhiButtonClick(Sender: TObject);
    procedure UpdatePhiButtonClick(Sender: TObject);
    procedure LinLogPhiClick(Sender: TObject);
    procedure XMinBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure XMaxBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure YMinBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure YMaxBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure XPhiMinBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure XPhiMaxBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure YPhiMinBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure YPhiMaxBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure XminBoxExit(Sender: TObject);
    procedure XmaxBoxExit(Sender: TObject);
    procedure YminBoxExit(Sender: TObject);
    procedure YmaxBoxExit(Sender: TObject);
    procedure XphiMinBoxExit(Sender: TObject);
    procedure XPhiMaxBoxExit(Sender: TObject);
    procedure YPhiMinBoxExit(Sender: TObject);
    procedure YPhiMaxBoxExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StoreCurvesClick(Sender: TObject);
    procedure StoreCurvesPhiClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
      { Dclarations prives}
  public
    procedure Transfer2CurveS(var Xcurve,Ycurve:Tvec;cindex:integer);
    procedure TransferCurveS(var Xcurve,Ycurve:Tvec;cindex:integer);
    procedure TransferCurve(var Xcurve,Ycurve:Tvec;index:integer);
    procedure TransferCurve2(var Xcurve,Ycurve:Tvec;index:integer);
    { Dclarations publiques}
  end;

var
  Graph2Dform: TGraph2Dform;

implementation

{$R *.DFM}
procedure TGraph2Dform.FormCreate(Sender: TObject);
var i:integer;
begin
left:=0;top:=0;width:=700;height:=450;
panel1.height:=400;panel2.height:=120;
for i:=1 to xygraph.lastseriesindex do begin xygraph[i].internalzero:=0; end;
for i:=1 to xygraph.lastseriesindex do begin xygraphphi[i].internalzero:=0; end;
{ initialisation des echelles dans les boites echelles }
XminBox.value:=xygraph.XAxis.min;XmaxBox.value:=xygraph.XAxis.max;
YminBox.value:=xygraph.YAxis.min;YmaxBox.value:=xygraph.YAxis.max;
XPhiminBox.value:=xygraphPhi.XAxis.min;XPhimaxBox.value:=xygraphPhi.XAxis.max;
YPhiminBox.value:=xygraphPhi.YAxis.min;YPhimaxBox.value:=xygraphPhi.YAxis.max;
end;

procedure TGraph2Dform.TransferCurveS(var Xcurve,Ycurve:Tvec;cindex:integer);
var i,nbrPoints:integer;
begin
curvespinedit.maxvalue:=20;
if curvespinedit.value>xygraph.LastSeriesIndex then curvespinedit.value:=7;
nbrPoints:=Xcurve.length;
cindex:=curvespinedit.value;
xyGraphPhi[cindex].clear;xyGraph[cindex].holdupdates:=true;
for i:=0 to nbrPoints-1 do
  begin
      xyGraph[cindex][Xcurve[i]]:=Ycurve[i];
  end;
xyGraph[cindex].holdupdates:=false;xyGraph[cindex].active:=true;
curvespinedit.value:=curvespinedit.value+1;
end;

procedure TGraph2Dform.Transfer2CurveS(var Xcurve,Ycurve:Tvec;cindex:integer);
var i,nbrPoints:integer;
begin
spineditphi.maxvalue:=4;
if spineditphi.value>3 then spineditphi.value:=1;

nbrPoints:=Xcurve.length;
cindex:=spineditphi.value;
xyGraphPhi[cindex].clear;xyGraphphi[cindex].holdupdates:=true;
for i:=0 to nbrPoints-1 do
  begin
      xyGraphphi[cindex][Xcurve[i]]:=Ycurve[i];
  end;
  xyGraphphi[cindex].holdupdates:=false;
  xyGraphphi[cindex].active:=true;
spineditphi.value:=spineditphi.value+1;
end;

{ procdure de transfert d'une courbe stocke dans un vecteur Tvec }
{ dans une serie du graphe2D                                       }
{ INPUT: Xcurve,Ycurve, 2 vecteurs contenant les abscisses et les ordonnes de la courbe }
{        index, l'index de la srie dans laquelle on veut tracer la courbe }
{ OUTPUT: la courbe est trace sur le graphe 2D                            }
{ REMARK: pas dfaut, ca clear la courbe existante                         }
procedure TGraph2Dform.TransferCurve(var Xcurve,Ycurve:Tvec;index:integer);
var i,nbrPoints:integer;
begin
  nbrPoints:=Xcurve.length;
  xyGraph[index].clear;
  xyGraph[index].holdupdates:=true;
  for i:=0 to nbrPoints-1 do
  begin
      xyGraph[index][Xcurve[i]]:=Ycurve[i];
  end;
  xyGraph[index].holdupdates:=false;
  xyGraph[index].active:=true;
end;

{ procdure de transfert d'une courbe stocke dans un vecteur Tvec                       }
{ dans une serie du graphe2Dphi  (deuxime fenetre graphique 2D                          }
{ INPUT: Xcurve,Ycurve, 2 vecteurs contenant les abscisses et les ordonnes de la courbe }
{        index, l'index de la srie dans laquelle on veut tracer la courbe               }
{ OUTPUT: la courbe est trace sur le graphe 2D                                          }
{ REMARK: pas dfaut, ca clear la courbe existante                                       }
procedure TGraph2Dform.TransferCurve2(var Xcurve,Ycurve:Tvec;index:integer);
var i,nbrPoints:integer;
begin
  nbrPoints:=Xcurve.length;
  xyGraphPhi[index].clear;xyGraphPhi[index].holdupdates:=true;
  for i:=0 to nbrPoints-1 do
  begin
      xyGraphPhi[index][Xcurve[i]]:=Ycurve[i];
  end;
  xyGraphPhi[index].holdupdates:=false;xyGraphPhi[index].active:=true;
end;

procedure TGraph2Dform.LinLogClick(Sender: TObject);
begin
     If LinLog.caption='Lin'
     then begin
          xygraph.Yaxis.Logscale:=True;
          LinLog.caption:='Log'
          end
     else begin
          xyGraph.Yaxis.Logscale:=False;
          LinLog.caption:='Lin'
          end;
{     redessiner }
end;

procedure TGraph2Dform.DataClick(Sender: TObject);
begin
      ShowxyDataWizard(self, xyGraph);
end;

procedure TGraph2Dform.PrintClick(Sender: TObject);
begin
     xygraph.print;
end;

procedure TGraph2Dform.RedessinerClick(Sender: TObject);
begin
{     redessiner; }
end;

procedure TGraph2Dform.EditGraphClick(Sender: TObject);
begin
     editxyGraph(self, xyGraph);
end;

procedure TGraph2Dform.YAutoClick(Sender: TObject);
begin
     if xygraph.yaxis.autosizing
     then begin
          xygraph.yaxis.autosizing:=false;
          Yauto.caption:='Y Man';
          end
     else begin
          xygraph.yaxis.autosizing:=true;
          xygraph.YAxis.autostepping:=true;
          Yauto.caption:='Y Auto';
          end;
end;

procedure TGraph2Dform.XAutoClick(Sender: TObject);
begin
if xygraph.xaxis.autosizing
     then begin
          xygraph.xaxis.autosizing:=false;
          xauto.caption:='X Man';
          end
     else begin
          xygraph.xaxis.autosizing:=true;
          xygraph.xAxis.autostepping:=true;
          xauto.caption:='X Auto';
          end;
end;


procedure TGraph2Dform.xyGraphMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     Xpos.text:=floattostrf(xygraph.GetMouseX(X),ffGeneral,3,2);
     Ypos.text:=floattostrf(xygraph.GetMouseY(Y),ffGeneral,3,2);
end;

procedure TGraph2Dform.ClearButtonClick(Sender: TObject);
var i:integer;
begin
     For i:=1 to xygraph.LastSeriesIndex do
     begin
          xyGraph[i].clear;
     end;
end;

{ mise a jour des echelles sur les deux graphes pour qu'elles se correspondent }
procedure TGraph2Dform.UpdateButtonClick(Sender: TObject);
begin
     xyGraphPhi.XAxis.Min:=xyGraph.xaxis.min;
     xyGraphPhi.XAxis.max:=xyGraph.xaxis.max;
     xyGraphPhi.XAxis.stepsize:=xyGraph.xaxis.stepsize;
end;

procedure TGraph2Dform.DataPhiClick(Sender: TObject);
begin
      ShowxyDataWizard(self, xyGraphPhi);
end;

procedure TGraph2Dform.PrintPhiClick(Sender: TObject);
begin
     xygraphphi.print;
end;

procedure TGraph2Dform.RedessinerPhiClick(Sender: TObject);
begin
xygraphphi.update;
end;

procedure TGraph2Dform.EditGraphPhiClick(Sender: TObject);
begin
     editxyGraph(self, xyGraphPhi);
end;

procedure TGraph2Dform.YPhiAutoClick(Sender: TObject);
begin
     if xygraphphi.yaxis.autosizing
     then begin
          xygraphphi.yaxis.autosizing:=false;
          yphiauto.caption:='YPhi Man';
          end
     else begin
          xygraphphi.yaxis.autosizing:=true;
          yphiauto.caption:='YPhi Auto';
          end;
end;

procedure TGraph2Dform.XPhiAutoClick(Sender: TObject);
begin
     if xygraphphi.xaxis.autosizing
     then begin
          xyGraphPhi.xaxis.autosizing:=false;
          xphiauto.caption:='XPhi Man';
          end
     else begin
          xygraphphi.xaxis.autosizing:=true;
          xphiauto.caption:='XPhi Auto';
          end;
end;

procedure TGraph2Dform.LinLogPhiClick(Sender: TObject);
begin
     If LinLogPhi.caption='Lin'
     then begin
          xygraphPhi.Yaxis.Logscale:=True;
          LinLogPhi.caption:='Log'
          end
     else begin
          xyGraphPhi.Yaxis.Logscale:=False;
          LinLogPhi.caption:='Lin'
          end;
end;


procedure TGraph2Dform.xyGraphPhiMouseMove(Sender: TObject;
  Shift: TShiftState; XPhi, YPhi: Integer);
begin
     XPhipos.text:=floattostrf(xygraphphi.GetMouseX(XPhi),ffGeneral,3,2);
     YPhipos.text:=floattostrf(xygraphphi.GetMouseY(YPhi),ffGeneral,3,2);
end;

procedure TGraph2Dform.ClearPhiButtonClick(Sender: TObject);
var i:integer;
begin
     For i:=1 to 10 do
     begin
          xyGraphPhi[i].clear;
     end;
end;

{ mise a jour des echelles sur les deux graphes pour qu'elles se correspondent }
procedure TGraph2Dform.UpdatePhiButtonClick(Sender: TObject);
begin
     xyGraphPhi.XAxis.Min:=xyGraph.xaxis.min;
     xyGraphPhi.XAxis.max:=xyGraph.xaxis.max;
     xyGraphPhi.XAxis.stepsize:=xyGraph.xaxis.stepsize;
end;


{controles des echelles de xygraph}
procedure Tgraph2dform.XminBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraph.XAxis.min:=XminBox.value;xygraph.update end;
end;

procedure Tgraph2dform.XmaxBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraph.XAxis.max:=XmaxBox.value;xygraph.update end;
end;

procedure Tgraph2dform.YminBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
     if key=13 then begin xygraph.YAxis.min:=YminBox.value;xygraph.update end;
     if key=38 then begin YminBox.text:=FloatToStrf(YminBox.value*10,ffGeneral,4,2);YminBox.update;xygraph.YAxis.min:=YminBox.value;xygraph.update end;
     if key=40 then begin YminBox.text:=FloatToStrf(YminBox.value/10,ffGeneral,4,2);YminBox.update;xygraph.YAxis.min:=YminBox.value;xygraph.update end;
end;

procedure Tgraph2dform.YmaxBoxKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
     if key=13 then begin xygraph.YAxis.max:=YmaxBox.value;xygraph.update end;
     if key=38 then begin YmaxBox.text:=FloatToStrf(YmaxBox.value*10,ffGeneral,4,2);YmaxBox.update;xygraph.YAxis.max:=YmaxBox.value;xygraph.update end;
     if key=40 then begin YmaxBox.text:=FloatToStrf(YmaxBox.value/10,ffGeneral,4,2);YmaxBox.update;xygraph.YAxis.max:=YmaxBox.value;xygraph.update end;
end;

procedure TGraph2Dform.XminBoxExit(Sender: TObject);
begin
xygraph.XAxis.min:=XminBox.value;
xygraph.update;
end;

procedure TGraph2Dform.XmaxBoxExit(Sender: TObject);
begin
xygraph.XAxis.max:=XmaxBox.value;
xygraph.update;
end;

procedure TGraph2Dform.YminBoxExit(Sender: TObject);
begin
xygraph.YAxis.min:=YminBox.value;
xygraph.update;
end;

procedure TGraph2Dform.YmaxBoxExit(Sender: TObject);
begin
xygraph.YAxis.max:=YmaxBox.value;
xygraph.update;
end;


{controles des echelles de xygraphphi}
procedure Tgraph2dform.XPhiminBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraphphi.XAxis.min:=XPhiminBox.value;xygraphphi.update end;
end;

procedure Tgraph2dform.XPhimaxBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraphphi.XAxis.max:=XPhimaxBox.value;xygraphphi.update end;
end;

procedure Tgraph2dform.YPhiminBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraphphi.YAxis.min:=YPhiminBox.value;xygraphphi.update end;
     if key=38 then begin YPhiminBox.text:=FloatToStrf(YPhiminBox.value*10,ffGeneral,4,2);YPhiminBox.update;xygraphPhi.YAxis.min:=YPhiminBox.value;xygraph.update end;
     if key=40 then begin YPhiminBox.text:=FloatToStrf(YPhiminBox.value/10,ffGeneral,4,2);YPhiminBox.update;xygraphPhi.YAxis.min:=YPhiminBox.value;xygraph.update end;
end;

procedure Tgraph2dform.YPhimaxBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin xygraphphi.YAxis.max:=YPhimaxBox.value;xygraphphi.update end;
     if key=38 then begin YPhimaxBox.text:=FloatToStrf(YPhimaxBox.value*10,ffGeneral,4,2);YPhimaxBox.update;xygraphPhi.YAxis.max:=YPhimaxBox.value;xygraph.update end;
     if key=40 then begin YPhimaxBox.text:=FloatToStrf(YPhimaxBox.value/10,ffGeneral,4,2);YPhimaxBox.update;xygraphPhi.YAxis.max:=YPhimaxBox.value;xygraph.update end;
end;

procedure TGraph2Dform.XphiMinBoxExit(Sender: TObject);
begin
xygraphphi.XAxis.min:=XPhiminBox.value;
xygraphphi.update;
end;

procedure TGraph2Dform.XPhiMaxBoxExit(Sender: TObject);
begin
xygraphphi.XAxis.max:=XPhimaxBox.value;
xygraphphi.update;
end;

procedure TGraph2Dform.YPhiMinBoxExit(Sender: TObject);
begin
xygraphphi.YAxis.min:=YphiminBox.value;
xygraphphi.update;
end;

procedure TGraph2Dform.YPhiMaxBoxExit(Sender: TObject);
begin
xygraphphi.YAxis.max:=YphimaxBox.value;
xygraphphi.update;
end;

{ procedure to store the curves so as to be able to compare newly calculated curves with a set of reference curves }
procedure TGraph2Dform.StoreCurvesClick(Sender: TObject);
var i:integer;
    x,y,rv:double;
    flag:boolean;
begin
xyGraph[7].clear;xyGraph[7].holdupdates:=true;
xyGraph[8].clear;xyGraph[8].holdupdates:=true;
xyGraph[9].clear;xyGraph[9].holdupdates:=true;
flag:=xygraph.series[4].GetFirstPoint(x, y, rv,i);
while flag do
begin xygraph.series[7].add(x,y);
      flag:=xygraph.series[4].GetNextPoint(x, y, rv,i); end;
flag:=xygraph.series[5].GetFirstPoint(x, y, rv,i);
while flag do
begin xygraph.series[8].add(x,y);
      flag:=xygraph.series[5].GetNextPoint(x, y, rv,i); end;
flag:=xygraph.series[6].GetFirstPoint(x, y, rv,i);
while flag do
begin xygraph.series[9].add(x,y);
      flag:=xygraph.series[6].GetNextPoint(x, y, rv,i); end;
xyGraph[7].holdupdates:=false;xyGraph[7].active:=true;
xyGraph[8].holdupdates:=false;xyGraph[8].active:=true;
xyGraph[9].holdupdates:=false;xyGraph[9].active:=true;
{ sauvegarde de la spin asymtrie }
xyGraphPhi[2].clear;xyGraphPhi[2].holdupdates:=true;
flag:=xygraphPhi.series[1].GetFirstPoint(x, y, rv,i);
while flag do
begin xygraphPhi.series[2].add(x,y);
      flag:=xygraphPhi.series[1].GetNextPoint(x, y, rv,i); end;
xyGraphPhi[2].holdupdates:=false;xyGraph[2].active:=true;
end;

procedure TGraph2Dform.StoreCurvesPhiClick(Sender: TObject);
var i:integer;
    x,y,rv:double;
    flag:boolean;
begin
{ sauvegarde de la spin asymtrie }
xyGraphPhi[2].clear;xyGraphPhi[2].holdupdates:=true;
flag:=xygraphPhi.series[1].GetFirstPoint(x, y, rv,i);
while flag do
begin xygraphPhi.series[2].add(x,y);
      flag:=xygraphPhi.series[1].GetNextPoint(x, y, rv,i); end;
xyGraphPhi[2].holdupdates:=false;xyGraph[2].active:=true;
end;

procedure TGraph2Dform.Button1Click(Sender: TObject);
var i:integer;
begin
     For i:=4 to xygraph.LastSeriesIndex do
     begin
          xyGraph[i].clear;
     end;
end;

end.
