program SimulReflec;

uses
  Forms,
  SimulReflecForm in 'SimulReflecForm.pas' {SimulReflecWindow},
  PilotageGraph2D in 'PilotageGraph2D.pas' {Graph2Dform},
  Surfaces2D in 'Surfaces2D.pas' {Surfaces2Dform},
  Optim in 'optim.pas',
  SimOpt in 'simopt.pas',
  about in 'about.pas' {AboutBox},
  EmailUnit in 'EmailUnit.pas' {SmtpForm},
  GaussLegendre in 'GaussLegendre.pas',
  MathAux in 'MathAux.pas',
  gratings in 'gratings.pas' {GratingsForm},
  constants in 'constants.pas';

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'SimulReflec V1.0';
  Application.CreateForm(TGraph2Dform, Graph2Dform);
  Application.CreateForm(TSimulReflecWindow, SimulReflecWindow);
{  Application.CreateForm(TGraph2Dform, Graph2Dform); }
  Application.CreateForm(TSurfaces2Dform, Surfaces2Dform);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TSmtpForm, SmtpForm);
  Application.CreateForm(TGratingsForm, GratingsForm);
  Application.Run;
end.
